<?php

namespace App\Entities\Extorno;

use App\Utils\Builder;

class ExtornoBuilder implements Builder {
	protected $id;
	protected $id_comanda;
	protected $id_tipo_extorno;
	protected $valor;
	protected $criado_por;
	protected $data_criacao;
	protected $hora_criacao;
	protected $observacao;

	public function build(): Extorno {

		$extorno = new Extorno();
		if (isset( $this->id )) {
			$extorno->setId( $this->id );
		}
		if (isset( $this->id_comanda )) {
			$extorno->setIdComanda( $this->id_comanda );
		}
		if (isset( $this->id_tipo_extorno )) {
			$extorno->setIdTipoExtorno( $this->id_tipo_extorno );
		}
		if (isset( $this->criado_por )) {
			$extorno->setCriadoPor( $this->criado_por );
		}
		if (isset( $this->data_criacao )) {
			$extorno->setDataCriacao( $this->data_criacao );
		}
		if (isset( $this->hora_criacao )) {
			$extorno->setHoraCriacao( $this->hora_criacao );
		}
		if (isset( $this->observacao )) {
			$extorno->setObservacao( $this->observacao );
		}
		if (isset( $this->valor )) {
			$extorno->setValor( $this->valor );
		}
		return $extorno;

	}

	public function setId(int $id): ExtornoBuilder {

		$this->id = $id;
		return $this;

	}

	/**
	 *
	 * @param mixed $id_comanda_fechamento
	 */
	public function setIdComanda($id_comanda): ExtornoBuilder {

		$this->id_comanda = $id_comanda;
		return $this;

	}

	/**
	 *
	 * @param mixed $id_tipo_extorno
	 */
	public function setIdTipoExtorno($id_tipo_extorno): ExtornoBuilder {

		$this->id_tipo_extorno = $id_tipo_extorno;
		return $this;

	}

	/**
	 *
	 * @param mixed $valor
	 */
	public function setValor($valor): ExtornoBuilder {

		$this->valor = $valor;
		return $this;

	}

	/**
	 *
	 * @param mixed $criado_por
	 */
	public function setCriadoPor($criado_por): ExtornoBuilder {

		$this->criado_por = $criado_por;
		return $this;

	}

	/**
	 *
	 * @param mixed $data_criacao
	 */
	public function setDataCriacao($data_criacao): ExtornoBuilder {

		$this->data_criacao = $data_criacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $hora_criacao
	 */
	public function setHoraCriacao($hora_criacao): ExtornoBuilder {

		$this->hora_criacao = $hora_criacao;
		return $this;

	}

	/**
	 *
	 * @param mixed $observacao
	 */
	public function setObservacao($observacao): ExtornoBuilder {

		$this->observacao = $observacao;
		return $this;

	}

}